diff -urN MSPDebugStack_OS_Package.orig/DLL430_v3/src/TI/DLL430/EnergyTrace_TSPA/EnergyTraceProcessorId7.h MSPDebugStack_OS_Package/DLL430_v3/src/TI/DLL430/EnergyTrace_TSPA/EnergyTraceProcessorId7.h
--- MSPDebugStack_OS_Package.orig/DLL430_v3/src/TI/DLL430/EnergyTrace_TSPA/EnergyTraceProcessorId7.h	2013-06-17 12:51:54.000000000 +0200
+++ MSPDebugStack_OS_Package/DLL430_v3/src/TI/DLL430/EnergyTrace_TSPA/EnergyTraceProcessorId7.h	2013-11-20 14:28:01.896457916 +0100
@@ -62,6 +62,7 @@
 #include "EnergyTraceProcessorJState.h"
 #include <DoubleBuffer.h>
 #include <stdint.h>
+#include <cstdio>
 
 //#define ETLOG
 
diff -urN MSPDebugStack_OS_Package.orig/Makefile MSPDebugStack_OS_Package/Makefile
--- MSPDebugStack_OS_Package.orig/Makefile	2013-06-17 12:51:54.000000000 +0200
+++ MSPDebugStack_OS_Package/Makefile	2013-11-20 14:28:01.910422680 +0100
@@ -15,10 +15,13 @@
 DEFINES += -DNDEBUG
 endif
 
+OS := $(shell uname -s)
+
 export BOOST_DIR
 export BIT32
 export STATIC
 export DEBUG
+export OS
 
 INCLUDES := \
 	-I./Bios/include \
@@ -33,6 +36,13 @@
 
 LIBDIRS := -L./ThirdParty/lib
 
+ifeq ($(OS),FreeBSD)
+	INCLUDES += -I/usr/local/include
+	LIBDIRS += -L/usr/local/lib
+else
+	LIBUSBSUFFIX := -1.0
+endif
+
 ifdef BOOST_DIR
 INCLUDES += -I$(BOOST_DIR)
 LIBDIRS += -L$(BOOST_DIR)/stage/lib
@@ -42,9 +52,9 @@
 STATIC_LIBS :=
 
 ifdef STATIC
-STATIC_LIBS += -lboost_thread -lboost_filesystem -lboost_date_time -lboost_system -lbsl430 -lusb-1.0 -lrt
+STATIC_LIBS += -lboost_thread -lboost_filesystem -lboost_date_time -lboost_system -lbsl430 -lusb$(LIBUSBSUFFIX) -lrt
 else
-LIBS += -lboost_thread -lboost_filesystem -lboost_date_time -lboost_system -lbsl430 -lusb-1.0 -lrt
+LIBS += -lboost_thread -lboost_filesystem -lboost_date_time -lboost_system -lbsl430 -lusb$(LIBUSBSUFFIX) -lrt
 endif
 
 LIBS += -lpthread
diff -urN MSPDebugStack_OS_Package.orig/ThirdParty/BSL430_DLL/Makefile MSPDebugStack_OS_Package/ThirdParty/BSL430_DLL/Makefile
--- MSPDebugStack_OS_Package.orig/ThirdParty/BSL430_DLL/Makefile	2013-01-28 10:34:24.000000000 +0100
+++ MSPDebugStack_OS_Package/ThirdParty/BSL430_DLL/Makefile	2013-11-20 14:28:01.915426350 +0100
@@ -25,6 +25,11 @@
 
 LIBDIRS :=
 
+ifeq ($(OS),FreeBSD)
+	INCLUDES += -I/usr/local/include
+	LIBDIRS += -L/usr/local/lib
+endif
+
 ifdef BOOST_DIR
 INCLUDES += -I$(BOOST_DIR)
 LIBDIRS += -L$(BOOST_DIR)/stage/lib
@@ -44,7 +49,7 @@
 OUTPUT := ../lib/libbsl430.a
 
 all: $(OBJS)
-	ar -cq $(OUTPUT) $(OBJS)
+	ar rcs $(OUTPUT) $(OBJS)
 
 %.o: %.cpp
 	$(CXX) -c -o $@ $< $(CXXFLAGS) $(INCLUDES) $(DEFINES)
diff -urN MSPDebugStack_OS_Package.orig/ThirdParty/install_thirdparty.sh MSPDebugStack_OS_Package/ThirdParty/install_thirdparty.sh
--- MSPDebugStack_OS_Package.orig/ThirdParty/install_thirdparty.sh	1970-01-01 01:00:00.000000000 +0100
+++ MSPDebugStack_OS_Package/ThirdParty/install_thirdparty.sh	2013-11-20 14:28:30.703457872 +0100
@@ -0,0 +1,48 @@
+#!/bin/sh
+
+rm -f lib/hid-libusb.o include/hidapi.h
+rm -rf hidapi
+
+git clone https://github.com/signal11/hidapi.git
+cd hidapi
+
+if [ "$( uname -s )" = "FreeBSD" ]
+then
+	# Use libusb_handle_events() instead of libusb_handle_events_completed()
+	# in libusb/hid.c
+	patch -b '' -p1 <<EOF
+diff --git a/libusb/hid.c b/libusb/hid.c
+index 6c1d247..2b4e192 100644
+--- a/libusb/hid.c
++++ b/libusb/hid.c
+@@ -757,7 +757,11 @@ static void *read_thread(void *param)
+ 	libusb_cancel_transfer(dev->transfer);
+ 
+ 	while (!dev->cancelled)
++#if defined(__FreeBSD__)
++		libusb_handle_events(usb_context);
++#else
+ 		libusb_handle_events_completed(usb_context, &dev->cancelled);
++#endif
+ 
+ 	/* Now that the read thread is stopping, Wake any threads which are
+ 	   waiting on data (in hid_read_timeout()). Do this under a mutex to
+EOF
+fi
+
+./bootstrap
+./configure
+make
+
+if [ ! -f hidapi/hidapi.h -o ! -f libusb/.libs/hid.o ]
+then
+	echo "hidapi: Build failed"
+	exit 1
+fi
+
+cp hidapi/hidapi.h ../include/hidapi.h && \
+cp libusb/.libs/hid.o ../lib/hid-libusb.o && \
+cd .. && \
+rm -rf hidapi
+echo "hidapi: Build ok (ignore any errors above)"
+
